//---------------------------------------------------------------------------
//    By Michael Shmalko 1997-98
//    mic@online.kharkiv.net
//    Please don't place Dxxx.cpp file in the internet or e-mail it.
//    Mail me for any reason.
//---------------------------------------------------------------------------
#ifndef DxxxH
#define DxxxH

#define TONE_U_BUSY    191
#define TONE_U_BUSYA   192
#define TONE_U_DIAL    193

#define SR_EVT         (WM_APP + 400)
#define MAX_CHAN       8

// Turn Type definitions
#define TT_NULL         0
#define TT_DIAL         1
#define TT_PLAY         2
#define TT_REC          3
#define TT_HOOK         4

#define TT_WTRING       5
#define TT_WTLCON       6
#define TT_WTLCOFF      7
#define TT_WTSILOFF     8
#define TT_WTSILON      9
#define TT_WTALL        10
#define TT_WTWINK       11
#define TT_WTDIGIT      12



// Turn Result definitions
#define TR_NULL         0
#define TR_OK           1
#define TR_ERR         -1
#define TR_DIG          2

//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <Inifiles.hpp>
#include "DataStorage.h"
#include <srllib.h>
#include <dxxxlib.h>
//---------------------------------------------------------------------------
class TPortCommand
{
public:
 int            Port;
 int            Type;
 int            Result;
 int            Hook;
 int            dID;
 int            Tag;
 unsigned short Length;
 AnsiString   Phone;
 AnsiString   Ident;
 char         Digit[64];
};
//---------------------------------------------------------------------------
class TPortConfig
{
public:
 int           chdev;
 int           Step;
 TPortCommand *LastCommand;
 DX_IOTT       iott;
 DV_DIGIT      digp;
 DV_TPT        tpt_a[9];
 DV_TPT        tpt_b[9];
};
//---------------------------------------------------------------------------
typedef void __fastcall ( __closure *TFOnLog)(int Port, AnsiString LogPhrase);
typedef void __fastcall ( __closure *TFOnBuf)(int f_handle, char *buf);
typedef void __fastcall ( __closure *TFOnTurn)(int Port, TPortCommand* Command);
typedef TDataStorage *PDataStorage;
//---------------------------------------------------------------------------
class TDX : public TThread
{
private:
 DX_CAP capp;
 int cares;
protected:
 void __fastcall DoAddCommand(void);
 void __fastcall Execute();
 TList           *CPool;
public:
 TPortCommand    *Command2Add;
 void __fastcall AddCommand(TPortCommand* Command);
 void __fastcall srEvent(TMessage &Message);
 TPortConfig     *PConfig[MAX_CHAN];
 int             ch_count;
 int             lcNumber[MAX_CHAN];// Number of last command number in list for spec. port
 void __fastcall DoError(int ch_dev);
 void __fastcall SayToLog(AnsiString LogPhrase, int Port);
 int  __fastcall GetChIdx(int ch_dev);
 void __fastcall ResetTerminators(int Port);
 void __fastcall ResetPort(int Port);
 
 TFOnLog         FOnLog;
 TFOnTurn        FOnTurn;
	__fastcall TDX(bool CreateSuspended);
};
//---------------------------------------------------------------------------
class PACKAGE TDxxx : public TCustomControl
{
private:
 DX_UIO          uioblk;
 TStringList     *DxxxList;

 void __fastcall DoError(int ch_dev);
 void __fastcall SayToLog(AnsiString LogPhrase, int Port);
 int  __fastcall GetChCount(void);
 void __fastcall SetChCount(int ch_count);
 void __fastcall OnDX1Terminated(System::TObject* Sender);

 TFOnLog __fastcall GetFOnLog(void);
 void    __fastcall SetFOnLog(TFOnLog FOnLog);

 TFOnTurn     __fastcall GetFOnTurn(void);
 void         __fastcall SetFOnTurn(TFOnTurn FOnTurn);
 TDataStorage* __fastcall GetStorage(void);
 void __fastcall SetStorage(TDataStorage *PStorage);
 void __fastcall SetFOnBuf(TFOnBuf fOnBuf);
 TFOnBuf __fastcall GetFOnBuf(void);
protected:
 TDX             *DX1;
 BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(SR_EVT, TMessage, DX1->srEvent)
 END_MESSAGE_MAP(TComponent)

public:
 
 __fastcall TDxxx(TComponent* Owner);
 __fastcall ~TDxxx();
 int  __fastcall InitChdev(void);
 int  __fastcall DoneChdev(void);
 void __fastcall Resume();
 void __fastcall Suspend();
 void __fastcall AddCommand(TPortCommand* Command);
 TIniFile       *ConfigIni;

__published:
 __property TFOnLog        OnLog        = { read = GetFOnLog,  write = SetFOnLog };
 __property TFOnTurn       OnTurn       = { read = GetFOnTurn, write = SetFOnTurn };
 __property int            ChCount      = { read = GetChCount, write = SetChCount, default = 2 };
 __property TDataStorage   *DataStorage = { read = GetStorage, write = SetStorage };
 __property TFOnBuf        OnBuf        = { read = GetFOnBuf,  write = SetFOnBuf };
};
//---------------------------------------------------------------------------
#endif
